program LaufZeit;
{$DEFINE DisableUTF8RTL}
{ $DEFINE DOS}
{ $DEFINE X86_64}
{ $DEFINE LINUX_32}
{ $DEFINE LINUX_64}
{$IFDEF LINUX_32} {$DEFINE LINUX} {$ENDIF}
{$IFDEF LINUX_64} {$DEFINE LINUX} {$ENDIF}
{$IFNDEF LINUX} {$IFNDEF DOS} {$DEFINE WIN_3264} {$ENDIF} {$ENDIF}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H-}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}

USES Stdio, Zeit, CRT, DOS;

CONST VERSION_INFO = 'Laufzeit   V 1.00 ' +
{$IFDEF LINUX_32} '(Linux 32)' {$ELSE} {$IFDEF LINUX_64} '(Linux 64)' {$ELSE}
{$IFDEF DOS}      '(16bit)' {$ELSE}
{$IFDEF X86_64}   '(64bit)' {$ELSE} '(32bit)' {$ENDIF} {$ENDIF} {$ENDIF}
{$ENDIF} + ' 04.08.2022   (c) ALFWARE B.Schubert';

CONST SLASH = {$IFDEF LINUX} '/' {$ELSE} '\' {$ENDIF} ;

VAR LG, LH, LM, LS, LMS: LONGINT;
    W: WORD;

procedure Program_Start;
begin
   Writeln('Parameterauswertung:');
   VAL(Paramstr(1), LMS, W);
   VAL(Paramstr(2), LS, W);
   VAL(Paramstr(3), LM, W);
   VAL(Paramstr(4), LH, W);
   LG:=(((LH * 60) + LM ) * 60 + LS ) * 1000 + LMS;
   Writeln(LH,' h, ', LM,' m, ', LS,' s, ',  LMS,' ms');
   Writeln('Gesamt: ', StrLong(LG),' ms');
   Writeln; Writeln(Intervall_Start(1));
end;

procedure Program_Ende;
begin
   Writeln(Intervall_Stop(1));
   Writeln(Intervall_Dauer(1));
end;

procedure Schleife;
begin
   if LG > 0 then delay(LG) else delay(100);
end;

begin
   ClrScr; Writeln(VERSION_INFO);
   Writeln; Writeln('Aufruf LAUFZEIT [MS [S [M [H] ] ] ]');
   Writeln; Writeln('Start-Stop Laufzeit eines Programmes...');
   Program_Start;
   Schleife;
   Program_Ende;
   Writeln; Writeln('Programmende');
end (* Laufzeit *).
